# medz/bots/cli.py
#
#

""" console programma voor de enkele gebruiker. """

__copyright__ = "Copyright 2015, B.H.J Thate"

## IMPORTS

from medz.defines import BLA, GREEN, ENDC
from medz.kernel import fleet, cfg
from medz.utils.time import short_date
from medz.bots import Bot
from medz.errors import RemoteDisconnect
from medz.thing import Thing

import time
import sys

## CLI

class CLI(Bot):

    """ bot running on the console. """

    cc = "none"
    default = ""

    def raw(zelf, *args, **kwargs): sys.stdout.write(args[0] + "\n") ; sys.stdout.flush()

    def say(zelf, *args, **kwargs): zelf.raw(args[1])

    def prompt(zelf, *args, **kwargs):
        zelf.wait()
        return "%s %s<%s " % (time.ctime(time.time()).split()[-2], GREEN, ENDC)

    def event(zelf, *args, **kwargs):
        event = Thing()
        event._target = zelf
        event.origin = "root@shell"
        zelf.ready()
        event.txt = input(zelf.prompt())
        return event

    def start(zelf, *args, **kwargs):
        fleet.append(zelf)
        if not cfg.shell:
            thrs = zelf.single(" ".join(cfg.runargs))
            if thrs: zelf.collect(thrs)
            zelf.ready()
            return
        Bot.start(zelf)
 