# medz/plugs/desk.py
#
#

""" show version. """

__copyright__ = "Copyright 2015, B.H.J Thate"

## IMPORTS

from medz.utils.string import to_str
from medz.utils.time import elapsed_days, elapsed
from medz.kernel import kernel, plugs, cfg
from medz.errors import error
from medz.clock import running
from medz import __version__

import threading
import time
import medz
import os

## CMNDS

def desk_copyright(event): event.reply(__copyright__)

kernel.register('desk.copyright', desk_copyright)

def desk_version(event): event.reply("MEDZ #%s - medicine effect registration program." % __version__)

kernel.register("desk.version", desk_version)

def desk_test(event): event.reply("hello %s" % event.origin)

kernel.register("desk.test", desk_test)

def desk_usage(event):
    data = os.popen("ps -p %s -o pid,tid,class,rtprio,ni,pri,psr,rss,pcpu,stat,wchan:14,comm" % os.getpid()).read().strip()
    event.reply(str(data))

kernel.register("desk.usage", desk_usage)

def desk_ls(event):
    if not event.parsed.rest:
       result = set([x.split(".")[-1] for x in kernel.names()])
       event.reply(", ".join(sorted(result)))
       return
    name = ""
    keys = kernel.search(event.parsed.rest)
    if keys: event.reply(", ".join(keys))
 
kernel.register("desk.ls", desk_ls)

def desk_plugs(event):
    rest = event.parsed.rest
    if not rest:
       result = set(plugs.names())
       event.reply(", ".join(sorted([".".join(x.split(".")[1:]) for x in result])))
       return
    name = ""
    keys = kernel.search(rest)
    event.reply(", ".join([".".join(x.split(".")[1:]) for x in keys]))
 
kernel.register("desk.plugs", desk_plugs)

def desk_cfg(event):
    obj = cfg
    if event.args:
        ctype = event.parsed.args[0]
        obj = kernel.last("cfg", ctype)
        if not obj: obj = getattr(medz.cfg, "cfg_%s" % ctype, None)
    try: 
        key = event.parsed.args[1]
        value = event.parsed.args[2]
        if key in obj: obj[key] = value ; obj.prefix = "cfg" ; obj.sync()
    except IndexError: pass
    if obj: event.reply("\n".join(obj.show()))

kernel.register("desk.cfg", desk_cfg)

def desk_uptime(event): event.reply("uptime is %s" % elapsed_days(time.time() - kernel._start))

kernel.register("desk.uptime", desk_uptime)

def desk_kernel(event): event.reply(kernel.pretty())

kernel.register("desk.kernel", desk_kernel)

def desk_where(event):
    name = event.parsed.rest
    cmnds = kernel.search(name)
    result = []
    for name in cmnds: result.extend([x.plugname for x in kernel.get(name)])
    if result: event.reply(", ".join(set(result)))

kernel.register("desk.where", desk_where)

## HELPERS

def until(obj): 
    try: return elapsed_days(int(obj.sleep) - int(time.time() - obj._last))
    except: error() ; return ""

def upt(obj):
    try: return elapsed_days(int(time.time()) - int(obj._start))
    except: return ""

def waiting(obj):
    if sleeptime(obj): return "%s/%s" % (until(obj), sleeptime(obj))
    else: return ""

def idle(obj):
    try: return elapsed_days(int(obj._last - obj._start))
    except: return ""

def since(obj):
    try: return elapsed_days(int(time.time()) - int(obj._last))
    except: return ""

def status(obj):
    try: return obj._status 
    except: return ""

def name(obj):
    try: return obj._name
    except: return ""

def running(obj):
    try: return obj._running
    except: return ""

def sleeptime(obj):
    try: return elapsed_days(obj.sleep)
    except: return ""

def plugname(obj):
    try: return obj.plugname
    except: return ""

funcs = [status, upt, waiting]

def desk_ps(event):
    from medz.clock import running
    threads = [x for x in threading.enumerate() if status(x)]
    for obj in sorted(threads, key=name):
        try: o = obj.func.__self__
        except: o = obj
        res = "%s: " % name(obj)
        for func in funcs:
            a = func(o)
            if not a: continue
            try: res += "%s " % a
            except: error()
        event.reply(res)
 
kernel.register("desk.ps", desk_ps)