# medz/dutch/store.py
#
#

""" storage. """

__copyright__ = "Copyright 2015, B.H.J Thate"

## IMPORTS

from medz.utils.time import short_date
from medz.kernel import kernel
from medz.thing import Thing

import time
import os

## CMNDS

def store_rm(event):
    try: key, match = event.args
    except ValueError: return
    nr = 0
    for fn in kernel.all(key):
       obj = Thing().load(fn)
       if key not in obj: continue
       if match not in obj[key]: continue
       obj.deleted = True
       obj.sync()
       nr += 1
    event.ok(nr)

kernel.register("store.rm", store_rm)

def store_back(event):
    try: key, match = event.args
    except ValueError: return
    nr = 0
    for fn in kernel.fns():
       obj = Thing().load(fn)
       if key not in obj: continue
       if match not in obj[key]: continue
       if "deleted" not in obj: continue
       obj.deleted = False
       obj.sync()
       nr += 1
    event.ok(nr)

kernel.register("store.back", store_back)

def store_first(event):
    fns = sorted(kernel.all(*event.parsed.args))
    if fns:
        obj = Thing().load(fns[0])
        event.reply(obj.json())

kernel.register("store.first", store_first)

def store_last(event):
    fns = sorted(kernel.all(*event.parsed.args))
    if fns:
        obj = Thing().load(fns[-1])
        event.reply(obj.json())

kernel.register("store.last", store_last)
