#!/usr/bin/env python3
#
#

import os
import sys

if sys.version_info.major < 3: print("you need to run medz with python3") ; os._exit(1)

try: use_setuptools()
except: pass

try:
    from setuptools import setup
except Exception as ex: print(str(ex)) ; os._exit(1)

from distutils import sysconfig
site_packages_path = sysconfig.get_python_lib()

setup(
    name='medz',
    version='16',
    url='https://pikacode.com/bthate/medz',
    author='Bart Thate',
    author_email='bthate@dds.nl',
    description="medicine effect registration program",
    license='MIT',
    zip_safe=True,
    install_requires=["beautifulsoup4", "sleekxmpp", "feedparser"],
    scripts=["bin/medz", ],
    packages=['medz',
              'medz.bots',
              'medz.plugs',
              'medz.extra',
              'medz.service',
              'medz.utils',
             ],
     long_description = """ 

Positive symptoms

 1) delusions
 2) hallucinations
 3) confused thinking
 4) excitement

Negative symptoms

 1) lac of emotions
 2) less social contact
 3) no initiative
 4) no concentration
 5) no motivation
 6) no energy

Affective symptoms

 1) depressive symptoms (fear)
 2) manical symptomen (pressure, full of energy, insomnia)

Fysical problems

 1) weight gain
 2) drool
 3) fry mouth
 4) thirst
 5) easily tired, no energy
 6) puking
 7) toileting
 8) headache
 9) weight loss
 10) blured vision
 11) sexual problems
 12) menstruation problems
 13) congestion
 14) dizzyness

Mental problems

 15) drowsiness
 16) trouble sleeping
 17) memory troubles
 18) trouble thinking/concentration
 19) psychotic phenomena get worse
 20) listlessness
 21) depressed
 22) fear

Muscle problems

 23) restless
 24) stiffness
 25) trembling
 26) slowness

""", 
    classifiers=[
        'Development Status :: 4 - Beta',
        'License :: OSI Approved :: MIT License',
        'Operating System :: Unix',
        'Programming Language :: Python',
        'Topic :: Software Development :: Libraries :: Python Modules'],
)
